import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.util.List;

/**
 * Write a description of class Bug here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public abstract class Bug extends Attackable
{
    public static final int MAX_HEALTH = 100;
    protected Nest nest;
    private int attackStep;
    private Shout shout;
    private double dxExtra, dyExtra;
    
    public Bug(Nest nest){
        super(MAX_HEALTH);
        this.nest = nest;
    }
    
    protected void addedToWorld(World world){
        ((Field)world).addToCount(this);
    }
    
    /**
     * Act - do whatever the Bug wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(doAct()){
            if(attackStep < 10) attackStep++;
            Nest nestFound = getNestFound();
            if(nestFound != null && nestFound != nest){
                attack(nestFound);
            }else{
                move();
                Bug intersection = (Bug)getOneIntersectingObject(Bug.class);
                attack(intersection);
            }
        }
    }  
    
    public Nest getNestFound(){
        return (Nest)getOneIntersectingObject(Nest.class);
    }
    
    public Nest getNest(){
        return nest;
    }
    
    // ---- Private ----
    
    private void move(){
        int speed = getSpeed();
        double angle = Math.toRadians( getRotation() );
        double dx = Math.cos(angle) * speed + dxExtra;
        double dy = Math.sin(angle) * speed + dyExtra;
        int dxInt = (int)Math.round(dx);
        int dyInt = (int)Math.round(dy);
        dxExtra = dx - dxInt;
        dyExtra = dy - dyInt;
        int x = getX() + dxInt;
        int y = getY() + dyInt;
        
        if(x >= getWorld().getWidth()) {
            x = 0;
        }
        if(x < 0) {
            x = getWorld().getWidth() - 1;
        }
        if(y >= getWorld().getHeight()) {
            y = 0;
        }
        if(y < 0) {
            y = getWorld().getHeight() - 1;
        }
        setLocation(x,y);
    }
    
    private void attack(Bug bug){
        if(attackStep >= 10 && bug != null && bug.getNest() != nest){
            int attackStrength = Greenfoot.getRandomNumber(100);
            //System.out.println("Attacking: "+attackStrength);
            if(attackStrength < getAttack()){
                attackStrength = (attackStrength*100) / getAttack();
                //System.out.println("getAttack() = "+getAttack());
                //System.out.println("attackStrength = "+attackStrength);
                attackStep = 0;
                bug.attack(attackStrength);
            }
        }
    }
    
    private boolean attack(Nest nest){
        if(attackStep >= 10 && nest != null){
            int attackStrength = Greenfoot.getRandomNumber(100);
            if(attackStrength < getAttack()){
                attackStrength = (attackStrength*100) / getAttack();
                nest.attack(attackStrength);
                attackStep = 0;
            }
            shout();
        }
        return true;
    }
    
    private void shout(){
        if(shout == null || shout.hasFinished()){
            shout = new Shout(this, getVolume());
            getWorld().addObject(shout, getX(), getY());
        }
        /*List bugs = getIntersectingObjects(Bug.class);
        for(Object obj: bugs){
            Bug bug = (Bug)obj;
            if(bug.getNest() == nest){
                int dx = getX() - bug.getX();
                int dy = getY() - bug.getY();
                double distance = Math.sqrt(dx*dx + dy*dy);
                double maxDistance = getVolume()*3;
                maxDistance = ((float)bug.getHearing()/100F) * maxDistance;
                if(distance <= maxDistance){
                    bug.shoutAt(this);
                }
            }
        }*/
    }
    
    public void hearShout(Shout shout){
        if(shout.getBug().getNest() == nest && Greenfoot.getRandomNumber(100)<getHearing()){            
            int deltaX = shout.getX() - getX();
            int deltaY = shout.getY() - getY();
            setRotation((int) (180 * Math.atan2(deltaY, deltaX) / Math.PI));
        }
    }
    
    // ---- Protected ----
    
    protected abstract int getSpeed();
    
    protected abstract int getVolume();
    
    protected abstract int getHearing();
    
    protected abstract int getDefense();
    
    protected abstract int getAttack();
}
