import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * Write a description of class Field here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Field extends World
{
    //private Button randomButton, soldierButton, scoutButton;
    private Slider slider;
    //Any dialog box that is being shown
    private Dialog dialog;
    //The level's name
    private Label caption;
    //The user's nest
    private Nest nest1;
    //The current level
    private int level = 1;
    //Should the level be set up (or ended) next time act is called?
    private boolean setupLevelOnNextAct = false, finishLevelOnNextAct = false;
    //Has the game started? Did the user win the last level?
    private boolean started = false, userWon;
    //Countdown to start game
    private int startCount = 0;
    //Did the user win each level?
    private boolean[] victory = new boolean[6];

    /**
     * Constructor for objects of class Field.
     * 
     */
    public Field()
    {    
        // Create a new world with 20x20 cells with a cell size of 10x10 pixels.
        super(800, 550, 1);
        setBackground("field.png");
        setPaintOrder(Dialog.class, Slider.class, Nest.class, Bug.class, Shout.class);
        
        slider = new Slider();
        slider.setValue(95);
        addObject(slider, 5+slider.getImage().getWidth()/2,
            getHeight()-5-slider.getImage().getHeight()/2-15);
        Label scoutLabel = new Label("Scouts",
        "", 0, 12,
        java.awt.Color.BLACK, null, false, false, false, null, null);
        addObject(scoutLabel, 5+scoutLabel.getImage().getWidth()/2,
            getHeight()-5-scoutLabel.getImage().getHeight()/2);
        Label soldierLabel = new Label("Soldiers",
        "", 0, 12,
        java.awt.Color.BLACK, null, false, false, false, null, null);
        addObject(soldierLabel,
            slider.getImage().getWidth()-soldierLabel.getImage().getWidth()/2,
            getHeight()-5-soldierLabel.getImage().getHeight()/2);
            
        dialog = new Dialog(true);
        dialog.addLabel("WarBugs", java.awt.Color.YELLOW, 40, dialog.getCentre(), 40);
        dialog.addLabel("You are the controller of a nest of blue bugs (on the left of the screen), which", java.awt.Color.WHITE, 10, dialog.getCentre(), 80);
        dialog.addLabel("is fighting a nest of red bugs (on the right).", java.awt.Color.WHITE, 10, dialog.getCentre(), 90);
        dialog.addLabel("There are two types of bugs you can send into battle:", java.awt.Color.WHITE, 10, dialog.getCentre(), 110);
        GreenfootImage image = new GreenfootImage("Bug_blue_soldier.png");
        image.rotate(315);
        dialog.addLabel("Soldier bugs, which attack enemy bugs and the enemy nest", java.awt.Color.WHITE, 10, dialog.getCentre(), 130, image);
        image = new GreenfootImage("Bug_blue_scout.png");
        image.rotate(315);
        dialog.addLabel("Scout bugs, which move much faster than the soldiers, seek out the enemy nest", java.awt.Color.WHITE, 10, dialog.getCentre(), 150, image);
        dialog.addLabel("& tell other bugs where it is", java.awt.Color.WHITE, 10, dialog.getCentre(), 160);
        dialog.addLabel("When bugs are telling other bugs where the nest is you can see circles moving", java.awt.Color.WHITE, 10, dialog.getCentre(), 180);
        dialog.addLabel("out from the shouting bug. When a bug is attacked a circle flashes around it:", java.awt.Color.WHITE, 10, dialog.getCentre(), 190);
        dialog.addLabel("red if it was killed, yellow if it wasn't.", java.awt.Color.WHITE, 10, dialog.getCentre(), 200);
        dialog.addLabel("Use the slider in the bottom left to control the proportion of soldiers & scouts sent out.", java.awt.Color.WHITE, 10, dialog.getCentre(), 220);
        dialog.addLabel("Press 'Run' to start", java.awt.Color.WHITE, 10, dialog.getCentre(), dialog.getImage().getHeight() - 20);
        addObject(dialog, getWidth()/2, getHeight()/2);
        setupLevelOnNextAct = true;
    }
    
    public void act(){
        if(!started){
            if(startCount == 0){
                removeObject(dialog);
                dialog = null;
                startCount++;
            }else if(startCount++ > 30){
                started = true;
            }
        }else if(doAct()){
            if(dialog != null) dialog = null;
            if(finishLevelOnNextAct){
                finishLevel();
                finishLevelOnNextAct = false;
            }else if(setupLevelOnNextAct){
                setupLevel();
                setupLevelOnNextAct = false;
            }
        }
    }
    
    public boolean doAct(){
        return dialog == null || dialog.getWorld() == null;
    }
    
    public void addToCount(Bug bug){
        if(bug.getNest() == nest1){
            if(bug instanceof Soldier){
                //soldierButton.increment();
            }else if(bug instanceof Scout){
                //scoutButton.increment();
            }
        }
    }
    
    public void removeFromCount(Bug bug){
        if(bug.getNest() == nest1){
            if(bug instanceof Soldier){
                //soldierButton.decrement();
            }else if(bug instanceof Scout){
                //scoutButton.decrement();
            }
        }
    }
    
    public void nestDestroyed(Nest nest){
        userWon = nest != nest1;
        nextLevel();
    }
    
    private void nextLevel(){
        finishLevelOnNextAct = true;
    }
    
    private void setupLevel(){
        removeObjects(getObjects(Attackable.class));
        removeObjects(getObjects(Shout.class));
        removeObjects(getObjects(Attack.class));
        if(caption != null) removeObject(caption);
        
        boolean stop = false;
        nest1 = Nest.createBlueNest();
        nest1.setSliderReleaseMethod(slider);
        Nest nest2 = Nest.createRedNest();
        nest2.setRotation(180);
        
        String levelName = null;
        if(level == 1){
            levelName = "Easy";
        }else if(level == 2){
            nest2.setReleaseMethod(Nest.METHOD_SCOUTS_FIRST);
            levelName = "Medium";
        }else if(level == 3){
            nest2.setReleaseMethod(Nest.METHOD_SOLDIERS_FIRST);
            levelName = "Medium";
        }else if(level == 4){
            nest2.setReleaseMethod(Nest.METHOD_INTELLIGENT);
            levelName = "Difficult";
        }else if(level == 5){
            nest2.setReleaseMethod(Nest.METHOD_INTEL_SCOUTS_FIRST);
            levelName = "Difficult";
        }else if(level == 6){
            nest2.setReleaseMethod(Nest.METHOD_INTEL_SCOUTS_FIRST);
            nest2.attack(-7000);
            levelName = "Impossible";
        }else{
            dialog = new Dialog(false);
            dialog.addLabel("The end", java.awt.Color.YELLOW, 30, dialog.getImage().getWidth()/2, 30);
            for(int i=0; i<victory.length; i++){
                dialog.addLabel("Level "+(i+1)+": You "+(victory[i]?"won":"lost"), java.awt.Color.WHITE, 10, dialog.getCentre(), 60 + 15*i);
            }
            addObject(dialog, getWidth()/2, getHeight()/2);
            stop = true;
        }
        if(!stop){
            //removeObject(dialog);
            String levelCaption = "Level "+level;
            if(levelName != null){
                levelCaption += " - "+levelName;
            }
            caption = new Label(levelCaption, 20);
            addObject(caption, caption.getImage().getWidth()/2, caption.getImage().getHeight()/2);
            addObject(nest1, 150, Greenfoot.getRandomNumber(getHeight()-300)+150);
            addObject(nest2, getWidth()-150, Greenfoot.getRandomNumber(getHeight()-300)+150);
        }else{
            Greenfoot.stop();
        }
    }
    
    private void finishLevel(){
        dialog = new Dialog();
        String title = userWon?"You won!":"You lost";
        dialog.addLabel(title, java.awt.Color.YELLOW, 30, dialog.getImage().getWidth()/2, 30);
        dialog.addLabel("Click this box to continue", java.awt.Color.WHITE, 10, dialog.getCentre(), dialog.getImage().getHeight() - 20);
        addObject(dialog, getWidth()/2, getHeight()/2);
        victory[level-1] = userWon;
        //Greenfoot.delay(100);
        //removeObject(dialog);
        level++;
        setupLevelOnNextAct = true;
    }
}
